import java.io.*;
import java.net.*;

public class TCPClient {
	public static void main(String args[]) throws Exception {
		String line;	// user input
		String server = "localhost";	// default server
		int port = 12345;		// server port
		BufferedReader userdata = new BufferedReader(new InputStreamReader(System.in));

		if (args.length > 1) {
			System.err.println("usage: java TCPClient server_name");
			System.exit(1);
		} else if (args.length == 1) {
			server = args[0];
			System.out.println("server = " + server);
		}

		Socket sock = new Socket(server, port);	// connect to the server
		System.out.println("connected!\n");
		DataOutputStream toServer = new DataOutputStream(sock.getOutputStream());
		BufferedReader fromServer = new BufferedReader(new InputStreamReader(sock.getInputStream()));

		while ((line = userdata.readLine()) != null) {
			toServer.writeBytes(line + '\n');	// send the line to the server
			String result = fromServer.readLine();	// read a one-line result
			System.out.println(result);		// print it
		}
		sock.close();	// we're done with the connection
	}
}
