import java.io.*;
import java.net.*;

public class TCPServer implements Runnable {
	Socket conn;

	TCPServer(Socket sock) {
		this.conn = sock;
	}

	public static void main(String args[]) throws Exception {
		int port = 12345;

		System.out.println("listening on port " + port);
		ServerSocket svc = new ServerSocket(port, 5);	// listen on port 12345

		for (;;) {
			Socket conn = svc.accept();	// get a connection from a client
			System.out.println("got a new connection from " 
				+ conn.getRemoteSocketAddress());

			new Thread(new TCPServer(conn)).start();
		}
	}

	public void run() {
		try {
			BufferedReader fromClient = new BufferedReader(new InputStreamReader(conn.getInputStream()));
			DataOutputStream toClient = new DataOutputStream(conn.getOutputStream());
			String line;

			while ((line = fromClient.readLine()) != null) {	// while there's data from the client
				System.out.println("got line \"" + line + "\"");

				String result = line.length() + ": " + line.toUpperCase() + '\n';	// do the work

				toClient.writeBytes(result);	// send the result

			}
			System.out.println("closing the connection\n");
			conn.close();		// close connection and exit the thread
		} catch (IOException e) {
			System.out.println(e);
		}
	}
}
